#include "stdio.h"
#include "conio.h"
#include "iopl32.h"
#define INCL_DOS
#define INCL_PM
#include "os2.h"
#include "tp_cmos.h"
#include "pmtposd.h"

static HBITMAP hbm[3];
static ULONG   id_timer;
static HAB     hab;
static UCHAR   type;
static ULONG   timeout;

#ifdef __WATCOMC__
 #define _outp outp
 #define _inp  inp
#endif
unsigned read_cmos(unsigned port)
{
   _outp(0x70,port);
   return ( _inp(0x71) );
}

void get_cmos(THINKPAD_CMOS *ptpc)
{
   enterIOPL32();
   ptpc->bKeyHome_Toggle        = ( read_cmos(ID_BYTE_INETKEY) & 0x01);
   ptpc->bKeySearch_Toggle      = ( read_cmos(ID_BYTE_INETKEY) & 0x02) >> 1;
   ptpc->bKeyMail_Toggle        = ( read_cmos(ID_BYTE_INETKEY) & 0x04) >> 2;
   ptpc->bKeyThinkpad_Toggle    = ( read_cmos(ID_BYTE_POWER_MISC) & 0x08) >> 3;
   ptpc->bKeyZoom_Toggle        = ( ~read_cmos(ID_BYTE_POWER_MISC)  & 0x20) >> 5;
   ptpc->bKeyDisplay_Toggle     = ( read_cmos(ID_BYTE_POWER_MISC) & 0x40) >> 6;
   ptpc->bKeyThinklight_Toggle  = ( read_cmos(ID_BYTE_THINKLIGHT) & 0x10) >> 4;
   ptpc->bHibernate_Toggle      = ( read_cmos(ID_BYTE_THINKLIGHT) & 0x01);
   ptpc->iSelectedDisplay       = ( read_cmos(ID_BYTE_DISPLAYSTATE) & 0x03);
   ptpc->bKeyExpand_Toggle      = ( read_cmos(ID_BYTE_DISPLAYSTATE) & 0x10) >> 4;
   ptpc->iBrightnessLevel       = ( read_cmos(ID_BYTE_BRIGHTNESS) & 0x07);
   ptpc->bKeyBrightness_Toggle  = ( read_cmos(ID_BYTE_BRIGHTNESS) & 0x20) >> 5;
   ptpc->iVolumeLevel           = ( read_cmos(ID_BYTE_VOLUME) & 0x0f);
   ptpc->bKeyVolume_Toggle      = ( read_cmos(ID_BYTE_VOLUME) & 0x80) >> 7;
   ptpc->bKeyMute_Toggle        = ( read_cmos(ID_BYTE_VOLUME) & 0x40) >> 6;
   leaveIOPL32();
}

MRESULT EXPENTRY proc_dlg(
             HWND hwnd,      /* handle of window */
             ULONG  msg,     /* id of message */
             MPARAM mp1,     /* first message parameter */
             MPARAM mp2)     /* second message parameter */
{
   HPS           hps;
   POINTL        ptl;
   USHORT        i;
   THINKPAD_CMOS tpc;

   switch(msg)
    {
       case WM_INITDLG:
                       timeout = 2*5;   /* 3*5*200ms = 3s */
                       hps = WinGetPS(hwnd);
                       switch(type)
                        {
                          case 'V':
                                   get_cmos(&tpc);
                                   if ( (tpc.bKeyMute_Toggle) == 1)
                                        hbm[0] = GpiLoadBitmap(hps,NULLHANDLE,ID_HPOFF ,0L,0L);
                                   else hbm[0] = GpiLoadBitmap(hps,NULLHANDLE,ID_HP    ,0L,0L);
                                   break;
                          case 'B':
                                   hbm[0] = GpiLoadBitmap(hps,NULLHANDLE,ID_BRIGHT,0L,0L);
                                   break;
                        }
                       hbm[1] = GpiLoadBitmap(hps,NULLHANDLE,ID_LEDON,0L,0L);
                       hbm[2] = GpiLoadBitmap(hps,NULLHANDLE,ID_LEDOFF,0L,0L);
                       WinReleasePS(hps);
                       id_timer = WinStartTimer(hab,hwnd,ID_TIMER,200L);
                       break;
       case WM_TIMER:  hps = WinGetPS(hwnd);
                       WinInvalidateRegion(hwnd,NULLHANDLE,0);
                       get_cmos(&tpc);
                       GpiDeleteBitmap(hbm[0]);
                       if (type == 'V')
                         {
                           if ( (tpc.bKeyMute_Toggle) == 1)
                                hbm[0] = GpiLoadBitmap(hps,NULLHANDLE,ID_HPOFF ,0L,0L);
                           else hbm[0] = GpiLoadBitmap(hps,NULLHANDLE,ID_HP    ,0L,0L);
                         }
                       ptl.x = 0;
                       ptl.y = 40;
                       WinDrawBitmap(hps,hbm[0],NULL,&ptl,0L,0L,DBM_NORMAL);
                       ptl.x += 60;
                       ptl.y  = 30;
                       switch(type)
                       {
                         case 'V':
                                  for(i=0;i<tpc.iVolumeLevel;i++)
                                   {
                                     WinDrawBitmap(hps,hbm[1],NULL,&ptl,0L,0L,DBM_NORMAL);
                                     ptl.x += 20;
                                   }
                                  for(i=tpc.iVolumeLevel;i<14;i++)
                                   {
                                     WinDrawBitmap(hps,hbm[2],NULL,&ptl,0L,0L,DBM_NORMAL);
                                     ptl.x += 20;
                                   }
                                  break;
                         case 'B':
                                  for(i=0;i<tpc.iBrightnessLevel;i++)
                                   {
                                     WinDrawBitmap(hps,hbm[1],NULL,&ptl,0L,0L,DBM_NORMAL);
                                     ptl.x += 20;
                                   }
                                  for(i=tpc.iBrightnessLevel;i<7;i++)
                                   {
                                     WinDrawBitmap(hps,hbm[2],NULL,&ptl,0L,0L,DBM_NORMAL);
                                     ptl.x += 20;
                                   }
                                  break;
                       }
                       WinReleasePS(hps);
                       timeout--;
                       if (timeout == 0)
                         {
                           WinStopTimer(hab,(HWND)0,id_timer);
                           WinDismissDlg(hwnd,TRUE);
                         }
                       break;
       case WM_PAINT:
                       get_cmos(&tpc);
                       hps = WinBeginPaint(hwnd, (ULONG) 0, 0);
                       ptl.x = 0;
                       ptl.y = 40;
                       WinDrawBitmap(hps,hbm[0],NULL,&ptl,0L,0L,DBM_NORMAL);
                       ptl.x += 60;
                       ptl.y  = 30;
                       switch(type)
                       {
                         case 'V':
                                  for(i=0;i<tpc.iVolumeLevel;i++)
                                   {
                                     WinDrawBitmap(hps,hbm[1],NULL,&ptl,0L,0L,DBM_NORMAL);
                                     ptl.x += 20;
                                   }
                                  for(i=tpc.iVolumeLevel;i<14;i++)
                                   {
                                     WinDrawBitmap(hps,hbm[2],NULL,&ptl,0L,0L,DBM_NORMAL);
                                     ptl.x += 20;
                                   }
                                  break;
                         case 'B':
                                  for(i=0;i<tpc.iBrightnessLevel;i++)
                                   {
                                     WinDrawBitmap(hps,hbm[1],NULL,&ptl,0L,0L,DBM_NORMAL);
                                     ptl.x += 20;
                                   }
                                  for(i=tpc.iBrightnessLevel;i<7;i++)
                                   {
                                     WinDrawBitmap(hps,hbm[2],NULL,&ptl,0L,0L,DBM_NORMAL);
                                     ptl.x += 20;
                                   }
                                  break;
                       }
                       WinEndPaint(hwnd);
                       break;
       default:
                       return WinDefDlgProc(hwnd, msg, mp1, mp2);
                       break;
    }
    return WinDefDlgProc(hwnd,msg,mp1,mp2);
}
int main(int argc,char **argv)
{
   HMQ           hmq;
   THINKPAD_CMOS tpc;
   int           old_iBrightnessLevel;
   int           old_iVolumeLevel;
   int           old_bKeyVolume_Toggle;
   int           old_bKeyMute_Toggle;
   int           old_bKeyBrightness_Toggle;

   hab = WinInitialize(0);
   hmq = WinCreateMsgQueue(hab,0);

   get_cmos(&tpc);
   old_iBrightnessLevel      = tpc.iBrightnessLevel;
   old_iVolumeLevel          = tpc.iVolumeLevel;
   old_bKeyMute_Toggle       = tpc.bKeyMute_Toggle;
   old_bKeyVolume_Toggle     = tpc.bKeyVolume_Toggle;
   old_bKeyBrightness_Toggle = tpc.bKeyBrightness_Toggle;
   for(;;)
    {
      while (old_iBrightnessLevel  == tpc.iBrightnessLevel &&
             old_iVolumeLevel      == tpc.iVolumeLevel &&
             old_bKeyMute_Toggle   == tpc.bKeyMute_Toggle &&
             old_bKeyVolume_Toggle == tpc.bKeyVolume_Toggle &&
             old_bKeyBrightness_Toggle == tpc.bKeyBrightness_Toggle)
      {
        get_cmos(&tpc);
        DosSleep(100);
      }

      if ( (old_iBrightnessLevel != tpc.iBrightnessLevel) ||
           (old_bKeyBrightness_Toggle != tpc.bKeyBrightness_Toggle))
        type = 'B';

      if ( (old_iVolumeLevel      != tpc.iVolumeLevel) ||
           (old_bKeyMute_Toggle   != tpc.bKeyMute_Toggle) ||
           (old_bKeyVolume_Toggle != tpc.bKeyVolume_Toggle))
        type = 'V';
      if (type == 'B' || type == 'V')
        WinDlgBox(HWND_DESKTOP,
                  HWND_DESKTOP,
                 (PFNWP) proc_dlg,
                 (HMODULE)0,
                 ID_SOUND,
                 NULL);
      get_cmos(&tpc);
      if (type == 'B')
        {
          old_iBrightnessLevel  = tpc.iBrightnessLevel;
          old_bKeyBrightness_Toggle = tpc.bKeyBrightness_Toggle;

        }
      if (type == 'V')
        {
          old_bKeyVolume_Toggle = tpc.bKeyVolume_Toggle;
          old_bKeyMute_Toggle   = tpc.bKeyMute_Toggle;
          old_iVolumeLevel      = tpc.iVolumeLevel;
        }
    }
   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
   return 0;
}
