/***************************************************************************/
/* F r e e C o d e                                                         */
/*                                                                         */
/* THIS CODE IS FREEWARE AND AS SUCH YOU ARE PERMITTED TO DO WHAT YOU WISH */
/* WITH IT. THESE PROGRAMS ARE PROVIDED AS IS WITHOUT ANY WARRANTY,        */
/* EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO FITNESS FOR ANY      */
/* PARTICULAR PURPOSE.                                                     */
/*                                                                         */
/* However, we would appriciate if you shared any enhancements to us       */
/* Please send them to www.jma.se/free/ and we will include them in        */
/* future distributions.                                                   */
/*                                                                         */
/***************************************************************************/
// tp_cmos.h
//---------------------------------------------------------------------------
// Headerfile for reading the cmos values from IBM Thinkpads
//
//---------------------------------------------------------------------------
// 021212: Started building
//---------------------------------------------------------------------------

#ifndef bool
#define bool BOOL
#endif


// constants definitions
//----------------------------------------------
#define ID_BYTE_AC              0x40
#define ID_BYTE_HIBERNATE       0x42
#define ID_BYTE_SUSPEND         0x45
#define ID_BYTE_POWERMODE       0x47
// byte 0x4d-0x52 RTC appointment (date/time/...)
#define ID_BYTE_INETKEY         0x64
#define ID_BYTE_POWER_MISC      0x65
#define ID_BYTE_THINKLIGHT      0x66
#define ID_BYTE_DISPLAYSTATE    0x67
#define ID_BYTE_BRIGHTNESS      0x6c
#define ID_BYTE_VOLUME          0x6E


// Structure definitions
//----------------------------------------------
typedef struct _THINKPAD_CMOS
        {
        bool    bKeyHome_Toggle;
        bool    bKeySearch_Toggle;
        bool    bKeyMail_Toggle;
        bool    bKeyThinkpad_Toggle;
        bool    bKeyZoom_Toggle;
        bool    bKeyDisplay_Toggle;
        bool    bKeyThinklight_Toggle;
        bool    bHibernate_Toggle;
        int     iSelectedDisplay;
        bool    bKeyExpand_Toggle;
        int     iBrightnessLevel;
        bool    bKeyBrightness_Toggle;
        int     iVolumeLevel;
        bool    bKeyVolume_Toggle;
        bool    bKeyMute_Toggle;
        } THINKPAD_CMOS;
typedef THINKPAD_CMOS *PTHINKPAD_CMOS;

// Function calls
//----------------------------------------------
void ThinkpadGetCMOSValues(PTHINKPAD_CMOS ptpc);

#ifdef __cplusplus
      extern "C" {
#endif


#ifdef __cplusplus
        }
#endif
